// BustAMove.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <stdio.h>
#include <time.h>
#include <math.h>

BOOL fatal=0;
#define erreurFatale(raison)	(MessageBox(NULL,raison,"Erreur fatale",MB_ICONERROR), fatal=1)
#include "globales.h"
#include "graphlib.h"
#include "sprites.h"
#include "fonctions.h"
#include "jeu.h"

#define MAX_LOADSTRING 100
#define MODE_ASYNCHRO
int		TIMER_RATE=    20;
#define MOYENNE_TEMPS
int		termine=1;

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;
	__int64 derSeconde, diff=0, derTrame;
	char str[100], captureTemps=0;
	int nbrePris=0, calcul;

	srand( (unsigned)time( NULL ) );

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_BUSTAMOVE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_BUSTAMOVE);

	__int64 start, end, freq, update_ticks_pc;

	// Get ticks-per-second of the performance counter.
	// Note the necessary typecast to a LARGE_INTEGER structure
	if (!QueryPerformanceFrequency((LARGE_INTEGER*)&freq))
		return -1;  // error - hardware doesn't support performance counter

	// Convert milliseconds per move to performance counter units per move.
	update_ticks_pc = TIMER_RATE * freq / 1000;

	// Initialize the counter.
	QueryPerformanceCounter((LARGE_INTEGER*)&start);
	QueryPerformanceCounter((LARGE_INTEGER*)&derSeconde);
	if (!RegisterHotKey(gblHWnd,1,MOD_CONTROL | MOD_WIN,'M'))	{
		cachable=0;
		MessageBox(gblHWnd,"Impossible d'assigner une touche de raccourci. Il sera impossible de cacher l'application!","Oups...",MB_ICONERROR);
	}
	else
		cachable=1;

	nFrames=0;
	// The main message loop begins here --
	while (1)
    {
		if (doitQuitter || fatal)		{
			PostQuitMessage(0);
			break;
		}

		if (PeekMessage(&msg, NULL, 0, 32767,PM_REMOVE))		{
			if (msg.message==WM_QUIT)
				break;
			if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}

		QueryPerformanceCounter((LARGE_INTEGER*)&end);
		// The inner loop ensures that the world gets updated more than 
		// once if need be.

		//Si a rame vraiment trop, on s'arrte compltement
		//C--d si aprs une seconde le jeu ne rpond plus, il sera mis en pause
/*		if ( (end-start) >= update_ticks_pc*10)	{
			Pause=1;
			start=end;
		}*/

#ifdef MOYENNE_TEMPS
		if (termine && captureTemps)	{
			diff+=end-derTrame;
			nbrePris++;
			captureTemps=0;
		}
#else
		if (termine && captureTemps)	{
			if (end-derTrame>diff)
				diff=end-derTrame;
			nbrePris=1;
			captureTemps=0;
		}
#endif

		if (touches['\t'] && (end-start) < update_ticks_pc && termine)
			start=end-update_ticks_pc;

		if ( (end-start) >= update_ticks_pc)
		{
			if ((end-derSeconde) >= freq*2)		{
/*				if (nFrames>=400)
					sprintf(str,"%s - %02i FPS [%ix]",szTitle,nFrames/2,nFrames/60);
				else
					sprintf(str,"%s - %02i FPS [%02i%%]",szTitle,nFrames/2,(100*(nFrames/2))/30);*/

				if (nbrePris!=0)		{
					calcul=(int)((1000000*diff/freq)/nbrePris);
					sprintf(str,"%s ~ %02ii/s,%ius,%i%%",szTitle,nFrames/2,calcul,calcul/(10*TIMER_RATE));
				}
				else
					sprintf(str,"%s ~ [Inactive]",szTitle);
				diff=0;
				nbrePris=0;

/*				float temps=1000.0/(nFrames/2.0);
				if (temps>=10.0)
					sprintf(str,"%s * %02i TPS [%#.1f ms]",szTitle,nFrames/2,temps);
				else if (temps>=1.0)
					sprintf(str,"%s * %02i TPS [%#.2f ms]",szTitle,nFrames/2,temps);
				else if (temps>=0.1)
					sprintf(str,"%s * %02i TPS [%i us]",szTitle,nFrames/2,(int)(temps*1000.0));
				else if (temps>=0.01)
					sprintf(str,"%s * %02i TPS [%#.1f us]",szTitle,nFrames/2,(float)(temps*1000.0));
				else if (temps>=0.001)
					sprintf(str,"%s * %02i TPS [%#.2f us]",szTitle,nFrames/2,(float)(temps*1000.0));*/
				SetWindowText(msg.hwnd,str);
				nFrames=0;
				derSeconde=end;
			}

			start += update_ticks_pc;

			Jeu();

#if defined(MODE_SYNCHRO)
			if ((end - start) <= freq/1000)		{
#elif defined(MODE_ASYNCHRO)
			if ((end - start) < update_ticks_pc)	{
#endif
				captureTemps=1;
				derTrame=end;
				PostMessage(gblHWnd,WM_TIMER,0,0);
			}

			if (bActive)
				termine=0;
		}
		if (!bActive)
			Sleep(1);

    } // End of message loop.
  return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_BUSTAMOVE);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_BUSTAMOVE;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, LARG, HAUT, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);
   gblHWnd=hWnd;

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//


LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	static int premiere_fois=1, fenX, fenY;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);

	switch (message) 
	{
		case WM_CREATE:
			RECT rect;
			GetClientRect(hWnd, &rect);

			fenX=LARG+LARG-rect.right;
			fenY=HAUT+HAUT-rect.bottom;
			SetWindowPos(hWnd,HWND_TOP,0,0,fenX,fenY,SWP_NOMOVE|SWP_NOZORDER);
			break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_KEYDOWN:
			int k;
			k=(int) wParam;
			if (k>=0 && k<=256)
				touches[k]=1;
			break;
		case WM_KEYUP:
			k=(int) wParam;
			if (k>=0 && k<=256)
				touches[k]=0;
			break;
		case WM_TIMER:
			InvalidateRect(hWnd,NULL,0);
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);

			if (premiere_fois==1)	{
				premiere_fois=0;
				InitGraphe(hdc);
				InitVars(0);
				InitVars(1);
				sprBordure=ChargeBmpDansSprite24("bordure.bmp");
				sprBarreFond=ChargeBmpDansSprite24("barreFond.bmp");
				sprPierre=ChargeBmpDansSprite24("pierre.bmp");
				sprBulles=ChargeBmpDansSprite24("bulles.bmp");
				mode=MODE_2J_ORDI;
//				mode=MODE_AUCUN;
				EndPaint(hWnd, &ps);
				InvalidateRect(hWnd,NULL,0);
				break;
			}

			DessineEcran();

			nFrames++;
			CopieEcran(hdc,rt);
			termine=1;

			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
