void InitGraphe(HDC hdc)		{
	char *null=NULL;
#define bpp 24
	hdcTemp=CreateCompatibleDC(hdc);
	Create(hdcTemp,LARG,HAUT,bpp,&hbmTemp,(void**)&null);
	PatBlt(hdcTemp,0,0,LARG,HAUT,BLACKNESS);

	hdcImage=CreateCompatibleDC(hdc);
	Create(hdcImage,LARG,HAUT,bpp,&hbm,(void**)&bitsImage);
	SelectObject (hdcImage, hbm);
	hpenEpais=CreatePen(PS_SOLID,2,RGB(255,255,255));
	hpenNormal=CreatePen(PS_SOLID,0,RGB(255,255,255));
	hbrushJaune=CreateSolidBrush(RGB(255,192,0));
	SelectObject(hdcImage,hpenNormal);
	SelectObject(hdcImage,hbrushJaune);
	hfont=CreateFont(16, 0, 0, 0, 0, 0, 0, 0, ANSI_CHARSET, 0, 0, 0, VARIABLE_PITCH | FF_DONTCARE, "Fixedsys"); 
	SelectObject(hdcImage,hfont);
}

void calcFenetre(int px, int py, int tx, int ty, int *xd, int *yd, int *dx, int *dy)		{
	float ex, ey, r;
	ex=(float)tx/(float)px;
	ey=(float)ty/(float)py;
	r=(float)px/(float)py;
	if (ex<ey)		{
		*dx=tx;
		*dy=(int)((float)tx/(float)r);
	}
	else	{
		*dx=(int)((float)ty*(float)r);
		*dy=ty;
	}
	*xd=(tx-*dx)/2;
	*yd=(ty-*dy)/2;
}

#define AGGRANDIT
#define bDBuffer 1

void CopieEcran(HDC hdc, RECT rect)	{
#ifdef AGGRANDIT
	int xd, yd, dx, dy, by;
	calcFenetre(LARG,HAUT,rect.right,rect.bottom,&xd,&yd,&dx,&dy);
	by=dy;

	if (bDBuffer==0)		{
		BitBlt(hdcTemp,0,0,LARG,HAUT,hdcImage,0,0,SRCCOPY);
		StretchBlt(hdc,xd,yd,dx,by,hdcTemp,0,0,LARG,HAUT,SRCCOPY);
	}
	else if (bDBuffer==1)	{
		StretchBlt(hdc,xd,yd,dx,by,hdcImage,0,0,LARG,HAUT,SRCCOPY);
	}
	else	{
		BitBlt(hdcTemp,0,0,LARG,HAUT,hdcImage,0,0,SRCCOPY);
		StretchBlt(GetDC(NULL),0,0,960,720,hdcTemp,0,0,LARG,HAUT,SRCCOPY);
	}

	PatBlt(hdc,0,0,xd,rect.bottom,BLACKNESS);
	PatBlt(hdc,0,0,rect.right,yd,BLACKNESS);
	PatBlt(hdc,xd+dx,0,rect.right-xd-dx,rect.bottom,BLACKNESS);
	PatBlt(hdc,0,yd+dy,rect.right,rect.bottom-dy-yd,BLACKNESS);
#else
	StretchBlt(hdc,0,0,LARG,HAUT,hdcImage,0,0,LARG,HAUT,SRCCOPY);
#endif
}
